﻿Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D

<Designer("System.Windows.Forms.Design.ParentControlDesigner, System.Design", GetType(IDesigner))> _
Public Class skinPanel

    Inherits Control

#Region "Constructor"

    Public Sub New()

        Me.SetStyle(ControlStyles.OptimizedDoubleBuffer, True)
        Me.Size = New Size(200, 200)

    End Sub

#End Region

#Region "Constants"

    Private display_rectangle As New Rectangle()
    Private SkinAttr As ImageAttributes

#End Region

#Region "Property Overrides"

    Public Overrides ReadOnly Property DisplayRectangle() As Rectangle
        Get
            display_rectangle = Rectangle.FromLTRB(4, 32, ClientRectangle.Width - 4, ClientRectangle.Height - 5)

            Return display_rectangle

        End Get
    End Property

#End Region

#Region "Methods"

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)

        ControlBackGround(e)
        ControlCaption(e)
        ControlTop(e)
        ControlTopLeft(e)
        ControlTopRight(e)
        ControlCaptionRight(e)
        ControlCaptionLeft(e)
        ControlRight(e)
        ControlLeft(e)
        ControlBottom(e)
        ControlText(e)

    End Sub

    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        Invalidate()

    End Sub

#End Region

#Region "Skin Methods"

    Private Sub ControlBackGround(ByVal e As PaintEventArgs)

        'Define a Clip Region
        Dim winBounds As New Rectangle(0, 0, Me.Width, Me.Height)
        Dim Rgn As New Region(winBounds)
        Dim clr As Color = Color.FromKnownColor(KnownColor.Control)
        Using brush As New SolidBrush(clr)

            e.Graphics.FillRegion(brush, Rgn)

        End Using

    End Sub

    Private Sub ControlCaption(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(50, 9, 2, 30)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, 8, ClientSize.Width, 24)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlTop(ByVal e As PaintEventArgs)
        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(50, 3, 2, 8)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, 0, ClientSize.Width, 8)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlBottom(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(11, 9, 2, 30)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, Me.Height - 4, Me.Width, 4)
        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)


    End Sub

    Private Sub ControlTopLeft(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(5, 3, 7, 8)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, 0, 4, 8)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlTopRight(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(89, 3, 7, 8)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(ClientSize.Width - 5, 0, 4, 8)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlCaptionRight(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(89, 9, 2, 30)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(ClientSize.Width - 4, 5, 4, 24)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlCaptionLeft(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(11, 9, 2, 30)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, 5, 4, 24)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub

    Private Sub ControlLeft(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(11, 9, 2, 20)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(0, 5, 4, Me.Height - 5)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)


    End Sub

    Private Sub ControlRight(ByVal e As PaintEventArgs)

        ' Create a Bitmap object from a file.
        Dim myBitmap As New Bitmap(My.Resources.SkinnyControl)

        ' Clone a portion of the Bitmap object.
        Dim cloneRect As New Rectangle(89, 9, 2, 20)
        Dim format As PixelFormat = myBitmap.PixelFormat
        Dim cloneBitmap As Bitmap = myBitmap.Clone(cloneRect, format)
        SkinAttr = New ImageAttributes()
        SkinAttr.SetWrapMode(WrapMode.Tile)
        Dim DestRect As New Rectangle(ClientSize.Width - 4, 5, 4, Me.Height - 5)

        ' Draw the cloned portion of the Bitmap object.
        e.Graphics.DrawImage(cloneBitmap, DestRect, 0, 0, cloneBitmap.Width, cloneBitmap.Height, GraphicsUnit.Pixel, SkinAttr)

    End Sub


    Private Sub ControlText(ByVal e As PaintEventArgs)

        If Not String.IsNullOrEmpty(Me.Text) Then
            Dim m_size As SizeF = e.Graphics.MeasureString(Me.Text, Me.Font)

            Using m_brush As Brush = New SolidBrush(Color.White)

                e.Graphics.DrawString(Me.Text, Me.Font, m_brush, 5, (32 - m_size.Height) / 2)

            End Using

        End If
    End Sub

#End Region

End Class
